using Library;
using MySystem.PxcModels;
using System;
using System.Linq;

namespace MySystem
{
    public class StoreChangeHistoryHelper
    {
        public readonly static StoreChangeHistoryHelper Instance = new StoreChangeHistoryHelper();
        private StoreChangeHistoryHelper()
        { }

        public string Start()
        {
            bool op = true;
            WebCMSEntities db = new WebCMSEntities();
            string result = "success";
            int total = 0;
            while (op)
            {
                StoreChangeHistory PopData = new StoreChangeHistory();
                try
                {
                    //获取apserver待同步的数据，执行入库
                    PopData = RedisDbconn.Instance.RPop<StoreChangeHistory>("Pop:StoreChangeHistory");
                    if (PopData != null)
                    {
                        // StoreChangeHistory checkExist = db.StoreChangeHistory.FirstOrDefault(m => m.Id == PopData.Id);
                        // if (checkExist != null)
                        // {
                        //     checkExist = PopData;
                        // }
                        // else
                        // {
                            db.StoreChangeHistory.Add(PopData);
                        // }
                        if (total >= 20)
                        {
                            total = 0;
                            db.SaveChanges();
                        }
                    }
                    else
                    {
                        db.SaveChanges();
                        op = false;
                    }
                }
                catch (Exception ex)
                {
                    ErrorMsg msg = new ErrorMsg();
                    msg.Obj = PopData;
                    msg.Time = DateTime.Now;
                    msg.ErrorContent = ex.ToString();
                    function.WriteLog(Newtonsoft.Json.JsonConvert.SerializeObject(msg), "Pop:StoreChangeHistory:Error");
                    result = "有异常，请查看Pop:StoreChangeHistory:Error队列";
                }
            }
            db.Dispose();
            return result;
        }
    }
}